---
title: AudioListener
slug: Web/API/AudioListener
tags:
  - API
  - AudioListener
  - Interface
  - Reference
  - Référence(2)
  - Web Audio API
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The <code>AudioListener</code> interface represents the position and orientation of the unique person listening to the audio scene, and is used in <a href="/en-US/docs/Web/API/Web_Audio_API/Web_audio_spatialisation_basics">audio spatialization</a>. All {{domxref("PannerNode")}}s spatialize in relation to the <code>AudioListener</code> stored in the {{domxref("BaseAudioContext.listener")}} attribute.</p>

<p>It is important to note that there is only one listener per context and that it isn't an {{domxref("AudioNode")}}.</p>

<p><img alt="We see the position, up and front vectors of an AudioListener, with the up and front vectors at 90° from the other." src="https://mdn.mozillademos.org/files/14311/WebAudioListenerReduced.png" style="display: block; margin: 0 auto;"></p>

<h2 id="Properties">Properties</h2>

<div class="note">
<p>The position, forward, and up value are set and retrieved using different syntaxes. Retrieval is done by accessing, for example, <code>AudioListener.positionX</code>, while setting the same property is done with <code>AudioListener.positionX.value</code>. This is why these values are not marked read only, which is how they appear in the specification's IDL.</p>
</div>

<dl>
	<dt>{{domxref("AudioListener.positionX")}}</dt>
	<dd>Represents the horizontal position of the listener in a right-hand cartesian coordinate sytem. The default is 0.</dd>
	<dt>{{domxref("AudioListener.positionY")}}</dt>
	<dd>Represents the vertical position of the listener in a right-hand cartesian coordinate sytem. The default is 0.</dd>
	<dt>{{domxref("AudioListener.positionZ")}}</dt>
	<dd>Represents the longitudinal (back and forth) position of the listener in a right-hand cartesian coordinate sytem. The default is 0.</dd>
	<dt>{{domxref("AudioListener.forwardX")}}</dt>
	<dd>Represents the horizontal position of the listener's forward direction in the same cartesian coordinate sytem as the position (<code>positionX</code>, <code>positionY</code>, and <code>positionZ</code>) values. The forward and up values are linearly independent of each other. The default is 0.</dd>
	<dt>{{domxref("AudioListener.forwardY")}}</dt>
	<dd>Represents the vertical position of the listener's forward direction in the same cartesian coordinate sytem as the position (<code>positionX</code>, <code>positionY</code>, and <code>positionZ</code>) values. The forward and up values are linearly independent of each other. The default is 0.</dd>
	<dt>{{domxref("AudioListener.forwardZ")}}</dt>
	<dd>Represents the longitudinal (back and forth) position of the listener's forward direction in the same cartesian coordinate sytem as the position (<code>positionX</code>, <code>positionY</code>, and <code>positionZ</code>) values. The forward and up values are linearly independent of each other. The default is -1.</dd>
	<dt>{{domxref("AudioListener.upX")}}</dt>
	<dd>Represents the horizontal position of the top of the listener's head in the same cartesian coordinate sytem as the position (<code>positionX</code>, <code>positionY</code>, and <code>positionZ</code>) values. The forward and up values are linearly independent of each other. The default is 0.</dd>
	<dt>{{domxref("AudioListener.upY")}}</dt>
	<dd>Represents the vertical position of the top of the listener's head in the same cartesian coordinate sytem as the position (<code>positionX</code>, <code>positionY</code>, and <code>positionZ</code>) values. The forward and up values are linearly independent of each other. The default is 1.</dd>
	<dt>{{domxref("AudioListener.upZ")}}</dt>
	<dd>Represents the longitudinal (back and forth) position of the top of the listener's head in the same cartesian coordinate sytem as the position (<code>positionX</code>, <code>positionY</code>, and <code>positionZ</code>) values. The forward and up values are linearly independent of each other. The default is 0.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref("AudioListener.setOrientation()")}} {{deprecated_inline}}</dt>
	<dd>Sets the orientation of the listener.</dd>
	<dt>{{domxref("AudioListener.setPosition()")}} {{deprecated_inline}}</dt>
	<dd>Sets the position of the listener.</dd>
</dl>

<div class="note">
<p><strong>Note</strong>: Although these methods are deprecated they are currently the only way to set the orientation and position in Firefox, Internet Explorer and Safari.</p>
</div>

<h2 id="Deprecated_features">Deprecated features</h2>

<dl>
	<dt>{{domxref("AudioListener.dopplerFactor")}} {{obsolete_inline}}</dt>
	<dd>A double value representing the amount of pitch shift to use when rendering a <a href="http://en.wikipedia.org/wiki/Doppler_effect">doppler effect</a>.</dd>
	<dt>{{domxref("AudioListener.speedOfSound")}} {{obsolete_inline}}</dt>
	<dd>Is a double value representing the speed of sound, in <em>meters per second</em>.</dd>
</dl>

<p>In a previous version of the specification, the <code>dopplerFactor</code> and <code>speedOfSound</code> properties and the <code>setPosition()</code> method could be used to control the doppler effect applied to {{domxref("AudioBufferSourceNode")}}s connected downstream — these would be pitched up and down according to the relative speed of the {{domxref("PannerNode")}} and the {{domxref("AudioListener")}}. These features had a number of problems:</p>

<ul>
	<li>Only {{domxref("AudioBufferSourceNode")}}s were pitched up or down, not other source nodes.</li>
	<li>The behavior to adopt when an {{domxref("AudioBufferSourceNode")}} was connected to multiple {{domxref("PannerNode")}}s was unclear.</li>
	<li>Because the velocity of the panner and the listener were not {{domxref("AudioParam")}}s, the pitch modification could not be smoothly applied, resulting in audio glitches.</li>
</ul>

<p>Because of these issues, these properties and methods have been removed.</p>

<p>The <code>setOrientation()</code> and <code>setPosition()</code> methods have been replaced by setting their property value equivilents. For example <code>setPosition(x, y, z)</code> can be achieved by setting <code>positionX.value</code>, <code>positionY.value</code>, and <code>positionZ.value</code> respectively.</p>

<h2 id="Example">Example</h2>

<p>{{page("/en-US/docs/Web/API/AudioContext.createPanner","Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Audio API', '#audiolistener', 'AudioListener')}}</td>
			<td>{{Spec2('Web Audio API')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioListener")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
